CREATE OR ALTER procedure ADDSTATTALONPROC (
    V_NUB_K char(10),
    V_SS char(14),
    V_SN_POL char(25),
    V_CKATL char(3),
    V_NY char(2),
    V_FAM varchar(40),
    V_IM varchar(40),
    V_OT varchar(40),
    V_W char(1),
    V_DR date,
    V_C_P char(2),
    V_SN_DOK char(25),
    V_ADRES varchar(100),
    V_GS char(1),
    V_SOC char(3),
    V_SN_INV char(1),
    V_D_ZA date,
    V_VID_O char(1),
    V_M_OBSL char(1),
    V_CEL_P char(1),
    V_XAR_Z char(1),
    V_D_UCH char(1),
    V_D_RA char(7),
    V_DATA_D_RA date,
    V_DB_ZA date,
    V_DB_OT date,
    V_BL char(1),
    V_PRIC_BL char(1),
    V_BL_UX_P char(1),
    V_BL_UX_VZ char(2),
    V_D_P_USL date,
    V_SP1 char(10),
    V_SP2 char(10),
    V_D_OS char(7),
    V_TERR char(4),
    V_INVAL char(1),
    V_TRAVMA char(2),
    V_REZ_OB char(2),
    V_OGRN char(15),
    V_D_ZAPOL date,
    V_ZAB_G char(1),
    V_COMPANY char(4),
    V_NUMBER_IN_REPORT integer,
    V_ID_REPORT integer,
    V_DISP_D char(1),
    V_K_MES varchar(11),
    V_MKOD char(6),
    V_DOST char(20),
    V_RMIS char(36),
    V_IDCASE integer,
    V_ST_REPEAT integer,
    V_MSE integer,
    V_DS_ONK integer,
    V_NPR_MO char(6),
    V_NPR_DATE date)
returns (
    ID_STATTALON integer)
as
BEGIN
   if (v_w = '') then v_w = '';
    if (v_w = '') then v_w = '';
    if (not EXISTS ( SELECT c_ogrn FROM lpu WHERE c_ogrn = :v_ogrn)) then
        select report.lpu_ogrn from report where id_report = :v_id_report into :v_ogrn;

    /* with foreign constraints checks  */
    ID_STATTALON = gen_id(gen_stattalon_id, 1);

    if (EXISTS ( SELECT shcompany FROM company WHERE (shcompany = :v_company and company.terr = :v_terr))
        and EXISTS ( SELECT sh_inv FROM inval_ WHERE sh_inv = :v_inval)
        and EXISTS ( SELECT code FROM nozolog WHERE code = :v_d_os)
        and EXISTS ( SELECT id_report FROM report WHERE id_report = :v_id_report)
        and EXISTS ( SELECT sh FROM rez_poseh WHERE sh = :v_rez_ob)
        and EXISTS ( SELECT kod FROM terr WHERE kod = :v_terr)
        and EXISTS ( SELECT sh FROM travma WHERE sh = :v_travma))     then
    begin

    INSERT INTO STATTALON(ID_STATTALON,
                          NUB_K,
                          SS,
                          SN_POL,
                          CKATL,
                          NY,
                          FAM,
                          IM,
                          OT,
                          W,
                          DR,
                          C_P,
                          SN_DOK,
                          ADRES,
                          GS,
                          SOC,
                          SN_INV,
                          D_ZA,
                          VID_O,
                          M_OBSL,
                          CEL_P,
                          XAR_Z,
                          D_UCH,
                          D_RA,
                          DATA_D_RA,
                          DB_ZA,
                          DB_OT,
                          BL,
                          PRIC_BL,
                          BL_UX_P,
                          BL_UX_VZ,
                          D_P_USL,
                          WAS_CHILD,
                          SP1,
                          SP2,
                          D_OS,
                          TERR,
                          INVAL,
                          TRAVMA,
                          REZ_OB,
                          OGRN,
                          D_ZAPOL,
                          ZAB_G,
                          COMPANY,
                          NUMBER_IN_REPORT,
                          summ,
                          reg_summ,
                          ID_REPORT,
                          DISP_D,
                          K_MES,
                          SUM_FSS,
                          VIB,
                          MOD_YCH,
                          ME_AB,
                          MKOD,
                          OK_FIN,
                          YET,
                          age,
                          dost,
                          RMIS,
                          ID_CASE_RMIS,
                          S_SUM,
                          ST_REPEAT,
                          MSE,
                          DS_ONK,
                          NPR_MO,
                          NPR_DATE)
    VALUES(:ID_STATTALON,
           :v_NUB_K,
           :v_SS,
           :v_SN_POL,
           :v_CKATL,
           :v_NY,
           :v_FAM,
           :v_IM,
           :v_OT,
           :v_W,
           :v_DR,
           :v_C_P,
           :v_SN_DOK,
           :v_ADRES,
           :v_GS,
           :v_SOC,
           :v_SN_INV,
           :v_D_ZA,
           :v_VID_O,
           :v_M_OBSL,
           :v_CEL_P,
           :v_XAR_Z,
           :v_D_UCH,
           :v_D_RA,
           :v_DATA_D_RA,
           :v_DB_ZA,
           :v_DB_OT,
           :v_BL,
           :v_PRIC_BL,
           :v_BL_UX_P,
           :v_BL_UX_VZ,
           :v_D_P_USL,
           -1,
           :v_SP1,
           :v_SP2,
           :v_D_OS,
           :v_TERR,
           :v_INVAL,
           :v_TRAVMA,
           :v_REZ_OB,
           :v_OGRN,
           :V_D_ZAPOL,
           :V_ZAB_G,
           :v_COMPANY,
           :v_NUMBER_IN_REPORT,
           0,
           0,
           :v_ID_REPORT,
           :v_disp_d,
           :v_k_mes,
           0,
           0,
           0,
           0,
           :v_mkod,
           0,
           0,
           0,
           :v_dost,
           :v_rmis,
           :v_idcase,
           0,
           :v_st_repeat,
           :v_mse,
           :v_ds_onk,
           :v_npr_mo,
           :v_npr_date
           );
    end
        else ID_STATTALON = -1;
END
